/* Base styles and content styles */

@import 'variables.css';

:root {
    /* Browser default font-size is 16px, this way 1 rem = 10px */
    font-size: 62.5%;
}

html {
    font-family: "Open Sans", sans-serif;
    color: var(--fg);
    background-color: var(--bg);
    text-size-adjust: none;
}

body {
    margin: 0;
    font-size: 1.6rem;
    overflow-x: hidden;
}

code {
    font-family: "Source Code Pro", Consolas, "Ubuntu Mono", Menlo, "DejaVu Sans Mono", monospace, monospace !important;
    font-size: 0.875em; /* please adjust the ace font size accordingly in editor.js */
}

/* Don't change font size in headers. */
h1 code, h2 code, h3 code, h4 code, h5 code, h6 code {
    font-size: unset;
}

.left { float: left; }
.right { float: right; }
.boring { opacity: 0.6; }
.hide-boring .boring { display: none; }
.hidden { display: none !important; }

h2, h3 { margin-top: 2.5em; }
h4, h5 { margin-top: 2em; }

.header + .header h3,
.header + .header h4,
.header + .header h5 {
    margin-top: 1em;
}

h1 a.header:target::before,
h2 a.header:target::before,
h3 a.header:target::before,
h4 a.header:target::before {
    display: inline-block;
    content: "»";
    margin-left: -30px;
    width: 30px;
}

h1 a.header:target,
h2 a.header:target,
h3 a.header:target,
h4 a.header:target {
    scroll-margin-top: calc(var(--menu-bar-height) + 0.5em);
}

.page {
    outline: 0;
    padding: 0 var(--page-padding);
    margin-top: calc(0px - var(--menu-bar-height)); /* Compensate for the #menu-bar-hover-placeholder */
}
.page-wrapper {
    box-sizing: border-box;
}
.js:not(.sidebar-resizing) .page-wrapper {
    transition: margin-left 0.3s ease, transform 0.3s ease; /* Animation: slide away */
}

.content {
    overflow-y: auto;
    padding: 0 15px;
    padding-bottom: 50px;
}
.content main {
    margin-left: auto;
    margin-right: auto;
    max-width: var(--content-max-width);
}
.content p { line-height: 1.45em; }
.content ol { line-height: 1.45em; }
.content ul { line-height: 1.45em; }
.content a { text-decoration: none; }
.content a:hover { text-decoration: underline; }
.content img { max-width: 100%; }
.content .header:link,
.content .header:visited {
    color: var(--fg);
}
.content .header:link,
.content .header:visited:hover {
    text-decoration: none;
}

table {
    margin: 0 auto;
    border-collapse: collapse;
}
table td {
    padding: 3px 20px;
    border: 1px var(--table-border-color) solid;
}
table thead {
    background: var(--table-header-bg);
}
table thead td {
    font-weight: 700;
    border: none;
}
table thead th {
    padding: 3px 20px;
}
table thead tr {
    border: 1px var(--table-header-bg) solid;
}
/* Alternate background colors for rows */
table tbody tr:nth-child(2n) {
    background: var(--table-alternate-bg);
}


blockquote {
    margin: 20px 0;
    padding: 0 20px;
    color: var(--fg);
    background-color: var(--quote-bg);
    border-top: .1em solid var(--quote-border);
    border-bottom: .1em solid var(--quote-border);
}


:not(.footnote-definition) + .footnote-definition,
.footnote-definition + :not(.footnote-definition) {
    margin-top: 2em;
}
.footnote-definition {
    font-size: 0.9em;
    margin: 0.5em 0;
}
.footnote-definition p {
    display: inline;
}

.tooltiptext {
    position: absolute;
    visibility: hidden;
    color: #fff;
    background-color: #333;
    transform: translateX(-50%); /* Center by moving tooltip 50% of its width left */
    left: -8px; /* Half of the width of the icon */
    top: -35px;
    font-size: 0.8em;
    text-align: center;
    border-radius: 6px;
    padding: 5px 8px;
    margin: 5px;
    z-index: 1000;
}
.tooltipped .tooltiptext {
    visibility: visible;
}

.chapter li.part-title {
    color: var(--sidebar-fg);
    margin: 5px 0px;
    font-weight: bold;
}

.panel {
    color: var(--panel-body-fg);
    margin-bottom: 27px;
    background-color: var(--panel-body-bg);
    border: 1px solid transparent;
    border-radius: 4px;
    -webkit-box-shadow: 0 1px 1px rgba(0, 0, 0, .05);
    box-shadow:0 1px 1px rgba(0, 0, 0, .05)
}

.panel-body {
    padding:15px
}

.panel-body:after, .panel-body:before {
    content: " ";
    display:table
}

.panel-body:after {
    clear:both
}

.panel-heading {
    display: flex;
    align-items: center;
    padding: 10px 15px;
    border-bottom: 1px solid transparent;
    border-top-right-radius: 3px;
    border-top-left-radius:3px
}

.panel-heading > .dropdown .dropdown-toggle, .panel-title {
    color:inherit
}

.panel-heading > p {
    margin: 0;
}

.panel-title {
    margin-top: 0;
    margin-bottom: 0;
    font-size:21px
}

.panel-title > .small, .panel-title > .small > a, .panel-title > a, .panel-title > small, .panel-title > small > a {
    color:inherit
}

.panel-footer {
    padding: 10px 15px;
    background-color: #f5f5f5;
    border-top: 1px solid #ddd;
    border-bottom-right-radius: 3px;
    border-bottom-left-radius:3px
}

.panel > .list-group, .panel > .panel-collapse > .list-group {
    margin-bottom:0
}

.panel > .list-group .list-group-item, .panel > .panel-collapse > .list-group .list-group-item {
    border-width: 1px 0;
    border-radius:0
}

.panel > .list-group:first-child .list-group-item:first-child, .panel > .panel-collapse > .list-group:first-child .list-group-item:first-child {
    border-top: 0;
    border-top-right-radius: 3px;
    border-top-left-radius:3px
}

.panel > .list-group:last-child .list-group-item:last-child, .panel > .panel-collapse > .list-group:last-child .list-group-item:last-child {
    border-bottom: 0;
    border-bottom-right-radius: 3px;
    border-bottom-left-radius:3px
}

.panel > .panel-heading + .panel-collapse > .list-group .list-group-item:first-child {
    border-top-right-radius: 0;
    border-top-left-radius:0
}

.list-group + .panel-footer, .panel-heading + .list-group .list-group-item:first-child {
    border-top-width:0
}

.panel > .panel-collapse > .table, .panel > .table, .panel > .table-responsive > .table {
    margin-bottom:0
}

.panel > .panel-collapse > .table caption, .panel > .table-responsive > .table caption, .panel > .table caption {
    padding-left: 15px;
    padding-right:15px
}

.panel > .table-responsive:first-child > .table:first-child, .panel > .table-responsive:first-child > .table:first-child > tbody:first-child > tr:first-child, .panel > .table-responsive:first-child > .table:first-child > thead:first-child > tr:first-child, .panel > .table:first-child, .panel > .table:first-child > tbody:first-child > tr:first-child, .panel > .table:first-child > thead:first-child > tr:first-child {
    border-top-right-radius: 3px;
    border-top-left-radius:3px
}

.panel > .table-responsive:first-child > .table:first-child > tbody:first-child > tr:first-child td:first-child, .panel > .table-responsive:first-child > .table:first-child > tbody:first-child > tr:first-child th:first-child, .panel > .table-responsive:first-child > .table:first-child > thead:first-child > tr:first-child td:first-child, .panel > .table-responsive:first-child > .table:first-child > thead:first-child > tr:first-child th:first-child, .panel > .table:first-child > tbody:first-child > tr:first-child td:first-child, .panel > .table:first-child > tbody:first-child > tr:first-child th:first-child, .panel > .table:first-child > thead:first-child > tr:first-child td:first-child, .panel > .table:first-child > thead:first-child > tr:first-child th:first-child {
    border-top-left-radius:3px
}

.panel > .table-responsive:first-child > .table:first-child > tbody:first-child > tr:first-child td:last-child, .panel > .table-responsive:first-child > .table:first-child > tbody:first-child > tr:first-child th:last-child, .panel > .table-responsive:first-child > .table:first-child > thead:first-child > tr:first-child td:last-child, .panel > .table-responsive:first-child > .table:first-child > thead:first-child > tr:first-child th:last-child, .panel > .table:first-child > tbody:first-child > tr:first-child td:last-child, .panel > .table:first-child > tbody:first-child > tr:first-child th:last-child, .panel > .table:first-child > thead:first-child > tr:first-child td:last-child, .panel > .table:first-child > thead:first-child > tr:first-child th:last-child {
    border-top-right-radius:3px
}

.panel > .table-responsive:last-child > .table:last-child, .panel > .table-responsive:last-child > .table:last-child > tbody:last-child > tr:last-child, .panel > .table-responsive:last-child > .table:last-child > tfoot:last-child > tr:last-child, .panel > .table:last-child, .panel > .table:last-child > tbody:last-child > tr:last-child, .panel > .table:last-child > tfoot:last-child > tr:last-child {
    border-bottom-right-radius: 3px;
    border-bottom-left-radius:3px
}

.panel > .table-responsive:last-child > .table:last-child > tbody:last-child > tr:last-child td:first-child, .panel > .table-responsive:last-child > .table:last-child > tbody:last-child > tr:last-child th:first-child, .panel > .table-responsive:last-child > .table:last-child > tfoot:last-child > tr:last-child td:first-child, .panel > .table-responsive:last-child > .table:last-child > tfoot:last-child > tr:last-child th:first-child, .panel > .table:last-child > tbody:last-child > tr:last-child td:first-child, .panel > .table:last-child > tbody:last-child > tr:last-child th:first-child, .panel > .table:last-child > tfoot:last-child > tr:last-child td:first-child, .panel > .table:last-child > tfoot:last-child > tr:last-child th:first-child {
    border-bottom-left-radius:3px
}

.panel > .table-responsive:last-child > .table:last-child > tbody:last-child > tr:last-child td:last-child, .panel > .table-responsive:last-child > .table:last-child > tbody:last-child > tr:last-child th:last-child, .panel > .table-responsive:last-child > .table:last-child > tfoot:last-child > tr:last-child td:last-child, .panel > .table-responsive:last-child > .table:last-child > tfoot:last-child > tr:last-child th:last-child, .panel > .table:last-child > tbody:last-child > tr:last-child td:last-child, .panel > .table:last-child > tbody:last-child > tr:last-child th:last-child, .panel > .table:last-child > tfoot:last-child > tr:last-child td:last-child, .panel > .table:last-child > tfoot:last-child > tr:last-child th:last-child {
    border-bottom-right-radius:3px
}

.panel > .panel-body + .table, .panel > .panel-body + .table-responsive, .panel > .table + .panel-body, .panel > .table-responsive + .panel-body {
    border-top:1px solid #ddd
}

.panel > .table > tbody:first-child > tr:first-child td, .panel > .table > tbody:first-child > tr:first-child th {
    border-top:0
}

.panel > .table-bordered, .panel > .table-responsive > .table-bordered {
    border:0
}

.panel > .table-bordered > tbody > tr > td:first-child, .panel > .table-bordered > tbody > tr > th:first-child, .panel > .table-bordered > tfoot > tr > td:first-child, .panel > .table-bordered > tfoot > tr > th:first-child, .panel > .table-bordered > thead > tr > td:first-child, .panel > .table-bordered > thead > tr > th:first-child, .panel > .table-responsive > .table-bordered > tbody > tr > td:first-child, .panel > .table-responsive > .table-bordered > tbody > tr > th:first-child, .panel > .table-responsive > .table-bordered > tfoot > tr > td:first-child, .panel > .table-responsive > .table-bordered > tfoot > tr > th:first-child, .panel > .table-responsive > .table-bordered > thead > tr > td:first-child, .panel > .table-responsive > .table-bordered > thead > tr > th:first-child {
    border-left:0
}

.panel > .table-bordered > tbody > tr > td:last-child, .panel > .table-bordered > tbody > tr > th:last-child, .panel > .table-bordered > tfoot > tr > td:last-child, .panel > .table-bordered > tfoot > tr > th:last-child, .panel > .table-bordered > thead > tr > td:last-child, .panel > .table-bordered > thead > tr > th:last-child, .panel > .table-responsive > .table-bordered > tbody > tr > td:last-child, .panel > .table-responsive > .table-bordered > tbody > tr > th:last-child, .panel > .table-responsive > .table-bordered > tfoot > tr > td:last-child, .panel > .table-responsive > .table-bordered > tfoot > tr > th:last-child, .panel > .table-responsive > .table-bordered > thead > tr > td:last-child, .panel > .table-responsive > .table-bordered > thead > tr > th:last-child {
    border-right:0
}

.panel > .table-bordered > tbody > tr:first-child > td, .panel > .table-bordered > tbody > tr:first-child > th, .panel > .table-bordered > tbody > tr:last-child > td, .panel > .table-bordered > tbody > tr:last-child > th, .panel > .table-bordered > tfoot > tr:last-child > td, .panel > .table-bordered > tfoot > tr:last-child > th, .panel > .table-bordered > thead > tr:first-child > td, .panel > .table-bordered > thead > tr:first-child > th, .panel > .table-responsive > .table-bordered > tbody > tr:first-child > td, .panel > .table-responsive > .table-bordered > tbody > tr:first-child > th, .panel > .table-responsive > .table-bordered > tbody > tr:last-child > td, .panel > .table-responsive > .table-bordered > tbody > tr:last-child > th, .panel > .table-responsive > .table-bordered > tfoot > tr:last-child > td, .panel > .table-responsive > .table-bordered > tfoot > tr:last-child > th, .panel > .table-responsive > .table-bordered > thead > tr:first-child > td, .panel > .table-responsive > .table-bordered > thead > tr:first-child > th {
    border-bottom:0
}

.panel > .table-responsive {
    border: 0;
    margin-bottom:0
}

.panel-group {
    margin-bottom:27px
}

.panel-group .panel {
    margin-bottom: 0;
    border-radius:4px
}

.panel-group .panel + .panel {
    margin-top:5px
}

.panel-group .panel-heading {
    border-bottom:0
}

.panel-group .panel-heading + .panel-collapse > .list-group, .panel-group .panel-heading + .panel-collapse > .panel-body {
    border-top:1px solid #ddd
}

.panel-group .panel-footer {
    border-top:0
}

.panel-group .panel-footer + .panel-collapse .panel-body {
    border-bottom:1px solid #ddd
}

.panel-default {
    border-color:#ddd
}

.panel-default > .panel-heading {
    color: #333;
    background-color: #f5f5f5;
    border-color:#ddd
}

.panel-default > .panel-heading + .panel-collapse > .panel-body {
    border-top-color:#ddd
}

.panel-default > .panel-heading .badge {
    color: #f5f5f5;
    background-color:#333
    margin-right: 3px;
}

.panel-default > .panel-footer + .panel-collapse > .panel-body {
    border-bottom-color:#ddd
}

.panel-primary {
    border-color:#6b4fbb
}

.panel-primary > .panel-heading {
    color: #fff;
    background-color: #6b4fbb;
    border-color:#6b4fbb
}

.panel-primary > .panel-heading + .panel-collapse > .panel-body {
    border-top-color:#6b4fbb
}

.panel-primary > .panel-heading .badge {
    color: #6b4fbb;
    background-color:#fff
    margin-right: 3px;
}

.panel-primary > .panel-footer + .panel-collapse > .panel-body {
    border-bottom-color:#6b4fbb
}

.panel-success {
    border-color: var(--success-bg);
}

.panel-success > .panel-heading {
    color: var(--success);
    background-color: var(--success-bg);
    border-color: var(--success-bg);
}

.panel-success > .panel-heading + .panel-collapse > .panel-body {
    border-top-color:#d6e9c6
}

.panel-success > .panel-heading .badge {
    color: var(--success);
    background-color: var(--success-bg);
    margin-right: 3px;
}

.panel-success > .panel-footer + .panel-collapse > .panel-body {
    border-bottom-color:#d6e9c6
}

.panel-info {
    border-color: var(--info-bg);
}

.panel-info > .panel-heading {
    color: var(--info);
    background-color: var(--info-bg);
    border-color:var(--info-bg);
}

.panel-info > .panel-heading + .panel-collapse > .panel-body {
    border-top-color:#bce8f1
}

.panel-info > .panel-heading .badge {
    color: var(--info);
    background-color:var(--info-bg);
    margin-right: 3px;
}

.panel-info > .panel-footer + .panel-collapse > .panel-body {
    border-bottom-color:#bce8f1
}

.panel-warning {
    border-color: var(--warning-bg);
}

.panel-warning > .panel-heading {
    color: var(--warning);
    background-color: var(--warning-bg);
    border-color: var(--warning-bg);
}

.panel-warning > .panel-heading + .panel-collapse > .panel-body {
    border-top-color:#faebcc
}

.panel-warning > .panel-heading .badge {
    color: var(--warning);
    background-color:var(--warning-bg);
    margin-right: 3px;
}

.panel-warning > .panel-footer + .panel-collapse > .panel-body {
    border-bottom-color:#faebcc
}

.panel-danger {
    border-color: var(--danger-bg);
}

.panel-danger > .panel-heading {
    color: var(--danger);
    background-color: var(--danger-bg);
    border-color: var(--danger-bg);
}

.panel-danger > .panel-heading + .panel-collapse > .panel-body {
    border-top-color:#ebccd1
}

.panel-danger > .panel-heading .badge {
    color: var(--danger);
    margin-right: 3px;
    background-color:var(--danger-bg);
}

.panel-danger > .panel-footer + .panel-collapse > .panel-body {
    border-bottom-color:#ebccd1
}
